<template>
    <div>
        <section class="hero">
            <div class="hero-body">
                <p class="title">
                    Admin portal
                </p>
            </div>
        </section>
        <section class="section">
            <h3 class="title">Edit contest description</h3>
            <b-tabs @input="tabChange">
                <b-tab-item label="Edit" value="edit">
                    <b-field>
                        <b-input custom-class="markdown-textarea" type="textarea" v-model="markdownText"></b-input>
                    </b-field>
                </b-tab-item>
                <b-tab-item label="Preview" value="preview">
                    <div class="box markdown-render">
                        <markdown-it-vue-light class="md-body" :content="renderText" :options="markdownOptions" />
                    </div>
                </b-tab-item>
            </b-tabs>
            <b-field>
                <b-button type="is-primary" @click="updateDescription">Save Description</b-button>
            </b-field>
        </section>
        <section class="section">
            <h3 class="title">Admin actions</h3>
            <b-field>
                <b-button type="is-info" @click="teamClick">
                    View teams
                </b-button>
            </b-field>
            <b-modal v-model="isTeamsTableModalActive">
                <div class="card">
                    <div class="card-header">
                        <h4 class="card-header-title">Currently registered teams</h4>
                    </div>
                    <div class="card-content">
                        <a href="/api/admin/teams/csv" download>Downlad as CSV</a>
                        <b-table
                            :data="teamsData"
                            :columns="teamsColumns"
                            paginated
                            sort-icon="arrow-up"
                            :scrollable="true"
                            per-page="15">
                        </b-table>
                    </div>
                </div>
            </b-modal>
            <b-field>
                <b-button type="is-info" @click="usersClick">
                    View users
                </b-button>
            </b-field>
            <b-modal v-model="isUsersTableModalActive">
                <div class="card">
                    <div class="card-header">
                        <h4 class="card-header-title">Currently registered users</h4>
                    </div>
                    <div class="card-content">
                        <a href="/api/admin/users/csv" download>Downlad as CSV</a>
                        <b-table
                            :data="usersData"
                            :columns="usersColumns"
                            checkable
                            :checked-rows.sync="adminUsers"
                            paginated
                            sort-icon="arrow-up"
                            :scrollable="true"
                            per-page="15">
                        </b-table>
                        <b-tooltip label="Make sure you don't remove admin from yourself!"
                                   position="is-right"
                                   type="is-danger"
                        >
                            <b-button type="is-primary" @click="postAdmins">
                                Make checked users admin
                            </b-button>
                        </b-tooltip>
                    </div>
                </div>
            </b-modal>
            <b-field>
                <b-button type="is-info" @click="submissionClick">
                    View submission log
                </b-button>
            </b-field>
            <b-modal v-model="isSubmissionsTableModalActive">
                <div class="card">
                    <div class="card-header">
                        <h4 class="card-header-title">Most recent submissions by team</h4>
                    </div>
                    <div class="card-content">
                        <b-table
                            :data="submissionData"
                            :columns="submissionColumns"
                            paginated
                            sort-icon="arrow-up"
                            per-page="15"
                            :scrollable="true"
                            @sort="sortTable"
                            backend-sorting
                            :default-sort="['date', 'desc']">
                        </b-table>
                    </div>
                </div>
            </b-modal>
            <b-field>
                <b-button type="is-info" @click="blackoutClick">
                    Pick submission blackout times
                </b-button>
            </b-field>
            <b-modal
                v-model="isBlackoutModalActive"
                scroll="keep"
                custom-class="blackout-modal"
                full-screen
            >
                <div class="modal-card">
                    <header class="modal-card-head">
                        <h4 class="modal-card-title">Pick blackout times</h4>
                    </header>
                    <section class="modal-card-body">
                        <p class="block">
                            Pick times that contestants will not be able to submit. Usually, this will be the weekly due date.
                        </p>
                        <div class="columns">
                            <nav class="panel column is-half">
                                <p class="panel-heading">
                                    Dates
                                </p>
                                <b-field
                                    v-for="(dateRange, i) in blackoutDateArray"
                                    :key="i"
                                    grouped
                                >
                                    <b-button
                                        tag="a"
                                        class="panel-block"
                                        :type="activeDateIndex === i ? 'is-primary is-light' : 'is-white'"
                                        expanded
                                        @click="selectDateRange(i)"
                                    >
                                        {{ formatDate(dateRange[0]) }} to {{ formatDate(dateRange[1]) }}
                                    </b-button>
                                    <b-button
                                        type="is-danger is-light"
                                        icon-right="trash"
                                        @click="deleteDateRange(i)"
                                    />
                                </b-field>
                                <div class="panel-block">
                                    <b-button
                                        type="is-primary"
                                        @click="addDateRange()"
                                    >
                                        Add new date range
                                    </b-button>
                                </div>
                            </nav>
                            <div class="column is-half" v-if="blackoutDateArray.length !== 0">
                                <b-field label="Select start of blackout">
                                    <b-datetimepicker
                                        v-model="blackoutStartDate"
                                        placeholder="Type or select a date..."
                                        icon="calendar-day"
                                        editable
                                        :min-datetime="currentDate"
                                        open-on-focus
                                        horizontal-time-picker
                                    ></b-datetimepicker>
                                </b-field>
                                <b-field label="Select end of blackout">
                                    <b-datetimepicker
                                        v-model="blackoutEndDate"
                                        placeholder="Type or select a date..."
                                        icon="calendar-day"
                                        editable
                                        :min-datetime="blackoutStartDate"
                                        open-on-focus
                                        horizontal-time-picker
                                    ></b-datetimepicker>
                                </b-field>
                                <b-field>
                                    <b-button
                                        type="is-primary"
                                        @click="saveDateRange()"
                                    >Save</b-button>
                                </b-field>
                            </div>
                            <div class="column is-half" v-else>
                                <p class="block">
                                    Add a date from the left panel
                                </p>
                            </div>
                        </div>
                    </section>
                    <footer class="modal-card-foot">
                        <b-field>
                            <b-button type="is-white" @click="closeBlackoutModal">Close</b-button>
                        </b-field>
                    </footer>
                </div>
            </b-modal>
            <b-field>
                <b-button type="is-info" @click="isSubmissionsDownloadModalActive = true">
                    Download Submissions
                </b-button>
            </b-field>
            <b-modal v-model="isSubmissionsDownloadModalActive" width="640px">
                <div class="card">
                    <div class="card-header">
                        <h4 class="card-header-title">Download submissions and script</h4>
                    </div>
                    <div class="card-content">
                        <form>
                            <b-field label="Contest format">
                                <b-radio v-model="contestFormat"
                                         name="format"
                                         native-value="friendly_stage">
                                    Random (friendly stage)
                                </b-radio>
                                <b-radio v-model="contestFormat"
                                         name="format"
                                         native-value="shift">
                                    Shift
                                </b-radio>
                                <b-radio v-model="contestFormat"
                                         name="format"
                                         native-value="full_round_robin">
                                    Full round-robin
                                </b-radio>
                            </b-field>
                            <b-field label="Country">
                                <b-radio v-model="country"
                                         v-for="nation in countries"
                                         :key="nation.id"
                                         name="country"
                                         :native-value="nation.id"
                                >
                                    {{ nation.name }}
                                </b-radio>
                                <b-radio v-model="country"
                                         name="country"
                                         native-value="all">
                                    All
                                </b-radio>
                            </b-field>
                            <b-field :label="paramLabel" v-show="contestFormat !== 'full_round_robin'">
                                <b-numberinput v-model="param"></b-numberinput>
                            </b-field>
                            <b-field>
                                <b-button
                                    tag="a"
                                    type='is-primary'
                                    :href="`/api/admin/submissions/${contestFormat}/${param}/${country}`"
                                    download>
                                    Download
                                </b-button>
                            </b-field>
                        </form>
                    </div>
                </div>
            </b-modal>
            <b-field grouped class="file is-primary" :class="{'has-name': !!contestInfo}">
                <b-upload v-model="contestInfo" class="file-label" accept=".zip" @input="checkContestInfoSize">
                    <span class="file-cta">
                        <b-icon class="file-icon" icon="upload"></b-icon>
                        <span class="file-label">Upload Contest Files</span>
                    </span>
                    <span class="file-name" v-if="contestInfo">
                        {{ cleanContestInfoName }}
                    </span>
                </b-upload>
                <b-tooltip label="Uploading a new file will overwrite the old one!">
                    <b-button class="is-success" @click="postAttachment('contestInfo')" :loading="isUploadLoading">Upload</b-button>
                </b-tooltip>
            </b-field>
            <b-field grouped class="file is-primary" :class="{'has-name': !!scoreboard}">
                <b-upload v-model="scoreboard" class="file-label" accept=".csv" @input="checkScoreboardSize">
                    <span class="file-cta">
                        <b-icon class="file-icon" icon="upload"></b-icon>
                        <span class="file-label">Upload Scoreboard</span>
                    </span>
                    <span class="file-name" v-if="scoreboard">
                        {{ cleanScoreboardName }}
                    </span>
                </b-upload>
                <b-tooltip label="Scoreboards should have dates so contestants can see when they're from">
                    <b-button class="is-success" @click="postAttachment('scoreboard')" :loading="isUploadLoading">Upload</b-button>
                </b-tooltip>
            </b-field>
        </section>
        <b-modal v-model="isProgressModalActive" :width="640" :can-cancel="false">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-header-title">Upload progress</h4>
                </div>
                <div class="card-content">
                    <p class="block">{{ uploadMessage }}</p>
                    <b-progress class="block" :value="uploadProgress" show-value format="percent"></b-progress>
                    <div class="block" v-if="showUploadCancel">
                        <b-button type="is-danger" @click="cancelUpload">Cancel</b-button>
                    </div>
                </div>
            </div>
        </b-modal>
    </div>
</template>

<script>
 import MarkdownItVueLight from 'markdown-it-vue/dist/markdown-it-vue-light.umd.min.js'
 import 'markdown-it-vue/dist/markdown-it-vue-light.css'
 export default {
     name: 'AdminPortal',
     components: { MarkdownItVueLight },
     computed: {
         paramLabel() {
             if (this.contestFormat === 'shift') {
                 return 'Week number'
             } else if (this.contestFormat === 'grouped_round_robin') {
                 return 'Group size'
             } else if (this.contestFormat === 'friendly_stage') {
                 return 'Number of opponents per team'
             }
             return 'No format selected'
         }
     },
     data() {
         return {
             isSubmissionsDownloadModalActive: false,
             isSubmissionsTableModalActive: false,
             isTeamsTableModalActive: false,
             isUsersTableModalActive: false,
             contestFormat: 'friendly_stage',
             country: 1,
             param: 1,
             markdownOptions: {
                 markdownIt: {
                     linkify: true,
                     typographer: true
                 }
             },
             markdownText: '',
             renderText: '',
             contestInfo: null,
             cleanContestInfoName: '',
             scoreboard: null,
             cleanScoreboardName: '',
             isUploadLoading: false,
             isProgressModalActive: false,
             xhr: null,
             uploadProgress: 0,
             uploadMessage: '',
             showUploadCancel: true,
             submissionData: [],
             submissionColumns: [
                 { field: 'teamId', label: 'Team ID', sortable: true },
                 { field: 'emoji', label: 'Team emoji', sortable: true },
                 { field: 'teamName', label: 'Team name', sortable: true },
                 { field: 'userId', label: 'User ID', sortable: true },
                 { field: 'name', label: 'Name', sortable: true },
                 { field: 'username', label: 'Username', sortable: true },
                 { field: 'email', label: 'Email', sortable: true },
                 { field: 'date', label: 'Date (local)', sortable: true },
                 { field: 'filePath', label: 'File path', sortable: true }
             ],
             teamsData: [],
             teamsColumns: [
                 { field: 'id', label: 'ID', sortable: true },
                 { field: 'emoji', label: 'Emoji', sortable: true },
                 { field: 'name', label: 'Name', sortable: true },
                 { field: 'country', label: 'Country', sortable: true },
                 { field: 'teamCode', label: 'Team code', sortable: true },
                 { field: 'latestSubmission', label: 'Latest submission', sortable: true },
             ],
             usersData: [],
             usersColumns: [
                 { field: 'id', label: 'ID', sortable: true },
                 { field: 'username', label: 'Username', sortable: true },
                 { field: 'first_name', label: 'First name', sortable: true },
                 { field: 'middle_name', label: 'Middle name', sortable: true },
                 { field: 'last_name', label: 'Last name', sortable: true },
                 { field: 'email', label: 'Email', sortable: true },
                 { field: 'phone_number', label: 'Phone', sortable: true },
                 { field: 'created_at', label: 'Created at', sortable: true },
                 { field: 'team_id', label: 'Team ID', sortable: true },
                 { field: 'is_admin', label: 'Is admin', sortable: true },
                 { field: 'is_email_confirmed', label: 'Email confirmed', sortable: true },
                 { field: 'email_confirm_code', label: 'Email confirm code', sortable: true },
                 { field: 'confirm_expires', label: 'Email confirm expires', sortable: true },
                 { field: 'github', label: 'Github', sortable: true },
                 { field: 'linkedin', label: 'LinkedIn', sortable: true },
                 { field: 'website', label: 'Website', sortable: true }
             ],
             isBlackoutModalActive: false,
             activeDateIndex: 0,
             currentDate: new Date(),
             blackoutDateArray: [],
             blackoutStartDate: this.currentDate,
             blackoutEndDate: null,
             countries: [],
             adminUsers: []
         }
     },
     methods: {
         tabChange(e) {
             if (e === 'preview') {
                 this.renderText = this.markdownText
             }
         },
         formatDate(date) {
             let options = {
                 year: 'numeric',
                 month: 'short',
                 day: 'numeric',
                 hour: 'numeric',
                 minute: 'numeric',
                 timeZoneName: 'short'
             }
             return new Intl.DateTimeFormat([], options).format(date)
         },
         selectDateRange(i) {
             this.blackoutStartDate = this.blackoutDateArray[i][0]
             this.blackoutEndDate = this.blackoutDateArray[i][1]
             this.activeDateIndex = i
         },
         addDateRange() {
             this.blackoutDateArray.push([new Date(), new Date()])
             this.selectDateRange(this.blackoutDateArray.length - 1)
         },
         deleteDateRange(i) {
             this.blackoutDateArray.splice(i, 1)
         },
         saveDateRange() {
             if (this.blackoutStartDate >= this.blackoutEndDate) {
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: "Please make sure your end date is strictly later than your start date",
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
                 return
             }
             this.blackoutDateArray[this.activeDateIndex][0] = this.blackoutStartDate
             this.blackoutDateArray[this.activeDateIndex][1] = this.blackoutEndDate
             this.$forceUpdate()
         },
         closeBlackoutModal() {
             if (this.blackoutDateArray.length === 0) {
                 this.isBlackoutModalActive = false
                 return
             }
             fetch('/api/admin/blackout', {
                 method: 'POST',
                 headers: {
                     'Content-Type': 'application/json;charset=utf-8'
                 },
                 body: JSON.stringify({ blackoutDateArray: this.blackoutDateArray })
             }).then((res) => {
                 if (res.ok) {
                     this.isBlackoutModalActive = false
                 } else {
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: 'Something went wrong',
                         position: 'is-bottom',
                         type: 'is-danger',
                         queue: false
                     })
                 }
             }).catch(() => {
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: 'Something went wrong',
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
             })
         },
         getContestDescription() {
             // GET contestDescription from API
             fetch('/api/contest-description/info')
                 .then((response) => {
                     if (response.ok) {
                         response.json().then((res) => {
                             this.markdownText = res.contestDescription
                             return   
                         })
                     }
                 })
                 .catch((e) => { console.error(e) })
         },
         updateDescription() {
             // send the new description to the server
             fetch('/api/contest-description/update', {
                 method: 'POST',
                 headers: {
                     'Content-Type': 'application/json;charset=utf-8'
                 },
                 body: JSON.stringify({ contestDescription: this.markdownText })
             }).then((res) => {
                 if (res.ok) {
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: 'Description successfully updated',
                         position: 'is-bottom',
                         type: 'is-success',
                         queue: false
                     })
                     this.getContestDescription()
                 } else {
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: 'Something went wrong. Please try again later',
                         position: 'is-bottom',
                         type: 'is-danger',
                         queue: false
                     })
                 }
             }).catch((e) => { console.error(e) })
         },
         checkScoreboardSize() {
             if (!this.scoreboard) {
                 return
             }
             this.cleanScoreboardName = this.scoreboard.name.replace(/[<>&]/g, '')
             if (this.scoreboard.size > 6000000000) {
                 // 6 gigabytes
                 this.scoreboard = null
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: 'File too big (limit 6 GB)',
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
             }
         },
         checkContestInfoSize() {
             if (!this.contestInfo) {
                 return
             }
             this.cleanContestInfoName = this.contestInfo.name.replace(/[<>&]/g, '')
             if (this.contestInfo.size > 6000000000) {
                 // 6 gigabytes
                 this.contestInfo = null
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: 'File too big (limit 6 GB)',
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
             }
         },
         cancelUpload() {
             this.xhr.abort()
         },
         postAttachment(fileName) {
             // send file to server
             if (this.isUploadLoading) {
                 // prevents additional clicks
                 return
             } else {
                 this.isUploadLoading = true
             }
             let file = fileName === 'scoreboard' ? this.scoreboard : this.contestInfo
             if (!file) {
                 this.isUploadLoading = false
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: 'No file selected for upload',
                     position: 'is-bottom',
                     type: 'is-danger'
                 })
                 return
             }
             if (fileName === 'contestInfo' && file.type !== 'application/zip') {
                 // check that attachment is a zip. mime types can be spoofed,
                 // so this isn't bulletproof
                 this.isUploadLoading = false
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: 'Make sure your attachment is a .zip',
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
                 return
             }
             if (fileName === 'scoreboard' && file.type !== 'text/csv') {
                 // if it's a scoreboard, check that it's a csv
                 this.isUploadLoading = false
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: 'Make sure your attachment is a .csv',
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
                 return
             }
             if (fileName === 'scoreboard') {
                 this.uploadMessage = "Uploading " + this.cleanScoreboardName
             } else if (fileName === 'contestInfo') {
                 this.uploadMessage = "Uploading " + this.cleanContestInfoName
             }
             this.isProgressModalActive = true
             let form = new FormData()
             form.append('attachment', file)
             let apiUrl = fileName === 'scoreboard' ? '/api/scoreboards/upload' : '/api/attachment/upload'
             this.xhr = new XMLHttpRequest()  // not fetch so we can track progress
             // listen for `upload.load` event
             this.xhr.upload.onload = () => {
                 // upload finished (still need to copy file)
                 this.showUploadCancel = false
                 this.uploadProgress = null  // indeterminate progress
                 this.uploadMessage = "Upload done; cleaning up (this might take a while)"
             }
             this.xhr.onload = () => {
                 // response finished (completely done)
                 this.isUploadLoading = false
                 this.isProgressModalActive = false
                 if (this.xhr.status === 200) {
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: 'File successfully uploaded',
                         position: 'is-bottom',
                         type: 'is-success',
                         queue: false
                     })
                 } else {
                     if (this.xhr.status === 429) {
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: "You've made too many requests. Please wait before submitting again",
                             position: 'is-bottom',
                             type: 'is-danger',
                             queue: false
                         })
                         return
                     }
                     if (this.xhr.status === 405) {
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: "The server detected that this file isn't the correct type. Please properly compress and try again",
                             position: 'is-bottom',
                             type: 'is-danger',
                             queue: false
                         })
                         return
                     }
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: 'Error in file upload',
                         position: 'is-bottom',
                         type: 'is-danger',
                         queue: false
                     })
                 }
             }
             // listen for `upload.error` event
             this.xhr.upload.onerror = () => {
                 this.isUploadLoading = false
                 this.isProgressModalActive = false
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: 'Error in file upload',
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
             }
             // listen for `upload.abort` event
             this.xhr.upload.onabort = () => {
                 this.isUploadLoading = false
                 this.isProgressModalActive = false
                 this.$buefy.toast.open({
                     duration: 2000,
                     message: 'Upload cancelled',
                     position: 'is-bottom',
                     type: 'is-warning'
                 })
             }
             // listen for `progress` event
             this.xhr.upload.onprogress = (event) => {
                 // event.loaded returns how many bytes are downloaded
                 // event.total returns the total number of bytes
                 // truncate progress to the tenths place
                 this.uploadProgress = Math.trunc(1000 * event.loaded / event.total) / 10
             }
             this.xhr.open('POST', apiUrl)
             this.xhr.send(form)
         },
         submissionClick() {
             this.getSubmissionsData()
             this.isSubmissionsTableModalActive = true
         },
         getSubmissionsData() {
             // get data for populating submissions table
             fetch('/api/admin/submissions/table')
                 .then((response) => {
                     if (response.ok) {
                         response.json().then((res) => {
                             let data = []
                             let submissions = res.submissions
                             for (let i=0; i<submissions.length; i++) {
                                 let row = {}
                                 row.userId = submissions[i].user_id
                                 row.name = submissions[i].first_name + ' ' + submissions[i].last_name
                                 row.filePath = submissions[i].file_path
                                 row.email = submissions[i].email
                                 row.teamId = submissions[i].team_id
                                 row.teamName = submissions[i].name
                                 row.username = submissions[i].username
                                 row.emoji = submissions[i].emoji
                                 if (submissions[i].created_at) {
                                     row.date = new Intl.DateTimeFormat([], {
                                         dateStyle: 'medium',
                                         timeStyle: 'short'
                                     }).format(new Date(submissions[i].created_at))
                                 }
                                 data.push(row)
                             }
                             this.submissionData = data
                             this.sortTable('date', 'desc')  // sort by date, most recent first
                             return
                         })
                                 .catch(() => this.toastWrong())
                     } else {
                         this.toastWrong()
                     }
                 })
                 .catch(() => this.toastWrong())
         },
         teamClick() {
             this.getTeamsData()
             this.isTeamsTableModalActive = true
         },
         getTeamsData() {
             // get data for populating teams table
             fetch('/api/admin/teams/table')
                 .then((response) => {
                     if (response.ok) {
                         response.json().then((res) => {
                             let data = []
                             let teams = res.teams
                             for (let i=0; i<teams.length; i++) {
                                 let row = {}
                                 row.id = teams[i].id
                                 row.name = teams[i].name
                                 row.country = teams[i].country_id
                                 row.emoji = teams[i].emoji
                                 row.teamCode = teams[i].team_code
                                 row.latestSubmission = teams[i].latest_submission
                                 data.push(row)
                             }
                             this.teamsData = data
                             return
                         }).catch(() => this.toastWrong())
                     } else {
                         this.toastWrong()
                     }
                 })
                 .catch(() => this.toastWrong())
         },
         usersClick() {
             this.getUsersData()
             this.isUsersTableModalActive = true
         },
         getUsersData() {
             // get data for populating users table
             fetch('/api/admin/users/table')
                 .then((response) => {
                     if (response.ok) {
                         response.json().then((res) => {
                             let data = []
                             let users = res.users
                             for (let i=0; i<users.length; i++) {
                                 let row = {}
                                 for (let prop in users[i]) {
                                     row[prop] = users[i][prop]
                                 }
                                 data.push(row)
                             }
                             this.usersData = data
                             this.adminUsers = this.usersData.filter(user => user.is_admin)
                             return
                         }).catch(() => this.toastWrong())
                     } else {
                         this.toastWrong()
                     }
                 })
                 .catch(() => this.toastWrong())
         },
         sortTable(field, order) {
             // custom sorting for table
             let modOrder = (order === 'asc') ? 1 : -1
             if (field !== 'date') {
                 // native sorting (alphabetical)
                 this.submissionData.sort((a, b) => { return (a[field] > b[field]) ? modOrder : (a[field] < b[field]) ? -modOrder : 0 })
             } else {
                 // date sorting
                 this.submissionData.sort((a, b) => {
                     return (new Date(a.date) - new Date(b.date)) * modOrder
                 })
             }
         },
         blackoutClick() {
             this.isBlackoutModalActive = true
         },
         toastWrong() {
             this.$buefy.toast.open({
                 duration: 3000,
                 message: 'Something went wrong',
                 position: 'is-bottom',
                 type: 'is-danger',
                 queue: false
             })
         },
         getBlackoutDates() {
             fetch('/api/user/blackout')
                 .then(response => response.json())
                 .then((json) => {
                     if (json.length === 0) {
                         return
                     }
                     this.blackoutDateArray = json.blackoutDates.map(date => [new Date(date[0]), new Date(date[1])])
                 }).catch(() => this.toastWrong())
         },
         getCountries() {
             // get the valid countries
             fetch('/api/user/register/countries')
                 .then((response) => {
                     if (response.ok) {
                         response.json().then(countries => this.countries = countries)
                     } else {
                         this.toastWrong()
                     }
                 }).catch((e) => {
                     console.error(e)
                     this.toastWrong()
                 })
         },
         postAdmins() {
             // update admins with checked users
             fetch('/api/admin/make', {
                 method: 'POST',
                 headers: {
                     'Content-Type': 'application/json;charset=utf-8'
                 },
                 body: JSON.stringify({ adminUsers: this.adminUsers })
             }).then(res => {
                 if (res.ok) {
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: 'Successfully updated admins',
                         position: 'is-bottom',
                         type: 'is-success',
                         queue: false
                     })
                 } else {
                     this.toastWrong()
                 }
             }).catch(() => this.toastWrong())
         }
     },
     created() {
         this.getContestDescription()
         this.getBlackoutDates()
         this.getCountries()
     }
 }
</script>
<style>
 .markdown-textarea {
     font-family: 'Monaco', 'Lucida Console', 'Courier New', monospace;
     font-size: 0.9em;
     height: 600px;
     max-height: 1000px;
 }
 .markdown-render {
     height: 600px;
     max-height: 700px;
     overflow: scroll;
 }
 .blackout-modal {
     overflow: scroll;
 }
</style>
